/*>>> jetpro.h: Jester chess engine function prototypes */

/*
 *	JETPRO.H
 *	Tom Kerrigan's Simple Chess Program (TSCP)
 *
 *	Copyright 1997 Tom Kerrigan
 *
 *  02-12-2001 10:54:44 new source names, stdtype.h
 *  02-13-2001  9:39:34 additional prototypes for board setups
 *  02-15-2001 15:27:01 longs for search() and quiesce()
 *             15:52:48 liT for eval()
 *  02-16-2001 15:27:37 reformat, stdtype.h
 *  02-20-2001 13:49:14 opening book prototypes
 *  05-14-2001 11:02:22 findSANMove prototype
 *             14:05:52 JETAllowCalls and JETRefuseCalls prototypes
 *  05-18-2001 11:33:50 JETFatal(), xboard_resign(), remove ch_pending()
 *  05-22-2001  9:37:17 JETLastEval()
 *  12-19-2001 14:08:00 Restore ch_pending()
 */

/* prototypes */

/* jetbrd.c */
void init();
boolT in_check(siT s);
boolT attack(siT sq, siT s);
void gen();
void gen_caps();
void gen_push(siT from, siT to, siT bits);
void gen_promote(siT from, siT to, siT bits);
boolT makemove(move_bytes m);
void takeback();

/* jetsrc.c */
liT JETLastEval(void);
void think(siT output);
liT search(liT alpha, liT beta, siT depth);
liT quiesce(liT alpha, liT beta);
siT reps();
void sort_pv();
void sort(siT from);
void checkup();

/* jetevl.c */
liT eval();
siT eval_light_pawn(siT sq);
siT eval_dark_pawn(siT sq);
siT eval_light_king(siT sq);
siT eval_lkp(siT f);
siT eval_dark_king(siT sq);
siT eval_dkp(siT f);

/* jetxbd.c */
void xboard(void);
void xboard_resign(void);

/* jetobk.c */
move FixBookMove(move);
boolT LoadOpeningBook(charptrT);
move lookup(void);

/* jester.c */
liT get_ms(void);
charptrT move_str(move_bytes);
mptrT findSANMove(move_bytes);
void JETFatal(void);
boolT ch_pending(void);

/* x_jester.c */
void JETAllowCalls(void); 
void JETRefuseCalls(void);

/* jetpro.h: EOF */
