/*>>> main.c: SAN project main program test driver */

/* Revised: 01-09-2002 20:48 */

/*
 * 02-12-2001 10:31:40 modified for stdtype.h
 * 02-14-2001 14:41:41 change banner
 * 02-16-2001 15:45:08 reformat
 * 02-19-2001 11:24:33 change banner again
 * 05-11-2001 10:45:21 Use SAN Kit I/O fns
 * 01-09-2002 20:48:00 Compile timestamp in banner
 */

#include <stdio.h>
#include <stdlib.h>

#include "stdtype.h"

#ifndef _LINUX
#include "SanKit\sandef.h"
#include "SanKit\sanvar.h"
#include "SanKit\sandsp.h"
#include "SanKit\sanint.h"
#include "SanKit\sancmd.h"
#include "SanKit\santrm.h"
#else
#include "SanKit/sandef.h"
#include "SanKit/sanvar.h"
#include "SanKit/sandsp.h"
#include "SanKit/sanint.h"
#include "SanKit/sancmd.h"
#include "SanKit/santrm.h"
#endif


#include "jetdef.h"


/*--> main: test driver main program for SAN standalone test */
nonstatic
int
main(siT argc, charptrT argv[], charptrT envp[])
  {
  siT argcount;
  char banner[80];
  
  setbuf(stdout, NULL);
  setbuf(stdin, NULL);
  setvbuf(stdout, NULL, _IONBF, 0);
  setvbuf(stdin, NULL, _IONBF, 0);   

#ifdef THINK_C
  argcount = 1;
  progname = "san";
#else
  argcount = argc;
  progname = argv[0];
#endif

/* sign on */

  sprintf(banner, "Jester %s  (%s %s)\n", JESTER_VERSION, __DATE__, __TIME__);
  SANDspLine(banner);

/* check arguments */

  if (argcount != 1)
    {
    fprintf(stderr, "%s: no command line arguments allowed\n", progname);
    exit(1);
    }
  ;

/* initialize */

  SANInit();

/* process commands */

  while (!progdone)
    SANCommand();

/* terminate */

  SANTerm();

  return (0);
  }

/*<<< main.c: EOF */
