/*>>> sanmpu.c: SAN project move play/unplay routines */

/* Revised: 02-12-2001 10:13:23 */

/* 02-12-2001 10:13:27 Modified for stdtype.h */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "stdtype.h"

#ifndef _LINUX
#include "SanKit\sandef.h"
#include "SanKit\sanvar.h"
#include "SanKit\sandsp.h"
#include "SanKit\sangtc.h"
#include "SanKit\sanhst.h"
#include "SanKit\sanmer.h"
#include "SanKit\sanmne.h"
#include "SanKit\sanmpu.h"
#include "SanKit\sanmsc.h"
#include "SanKit\sansrt.h"
#include "SanKit\sansss.h"
#include "SanKit\sanutl.h"
#include "SanKit\sanval.h"
#else
#include "SanKit/sandef.h"
#include "SanKit/sanvar.h"
#include "SanKit/sandsp.h"
#include "SanKit/sangtc.h"
#include "SanKit/sanhst.h"
#include "SanKit/sanmer.h"
#include "SanKit/sanmne.h"
#include "SanKit/sanmpu.h"
#include "SanKit/sanmsc.h"
#include "SanKit/sansrt.h"
#include "SanKit/sansss.h"
#include "SanKit/sanutl.h"
#include "SanKit/sanval.h"
#endif



/*--> SANPlayMove: play a move */
nonstatic
void
SANPlayMove(mptrT mptr)
  {
/* locate move in current list */

  curr_g.g_curr = SANFindMove(mptr);
  if (curr_g.g_curr == NULL)
    SANFatal("SANPlayMove: can't find move");

/* echo move */

  if (!optnv[optn_namd])
    SANDspFullMove(curr_e.e_fmvn, curr_g.g_curr);

/* save transition information */

  prev_e = curr_e;
  prev_m = *curr_g.g_curr;
  prev_b = gb;

/* push to history */

  SANHistPush(SANLocateOrdinal(mptr));

/* execute the move */

  SANExecute();

/* drop analysis index (current ply) */

  an--;

/* regenerate current level */

  SANUpdate();

/* handle game termination */

  SANGTCAutoSet();

/* board display */

  if (!optnv[optn_nabd])
    SANDspBoard();

/* strategies */

  SANSSS(sep_play);

  return;
  }

/*--> SANUnplayMove: unplay the last played move */
nonstatic
void
SANUnplayMove(void)
  {
/* save transition information (except for the move) */

  prev_e = curr_e;
  prev_b = gb;

/* "Activate the WayBack Machine, Sherman!" */

  SANHistPop();

/* save transition move information */

  prev_m = *curr_g.g_curr;

/* echo move */

  if (!optnv[optn_namd])
    SANDspFullMove(curr_e.e_fmvn, curr_g.g_curr);

/* board display */

  if (!optnv[optn_nabd])
    SANDspBoard();

/* undo game termination */

  SANGTCSet(gtc_norm);

/* strategies */

  SANSSS(sep_unplay);

  return;
  }

/*<<< sanmpu.c: EOF */
