/*>>> santrm.c: SAN project terminations */

/* Revised: 02-12-2001 10:20:05 */

/* 02-12-2001 10:20:09 Modified for stdtype.h */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "stdtype.h"

#ifndef _LINUX
#include "SanKit\sandef.h"
#include "SanKit\sanvar.h"
#include "SanKit\sancmd.h"
#include "SanKit\sanepd.h"
#include "SanKit\sanhsh.h"
#include "SanKit\sanhst.h"
#include "SanKit\sanpos.h"
#include "SanKit\sansss.h"
#include "SanKit\santag.h"
#include "SanKit\santrm.h"
#include "SanKit\sanutl.h"
#else
#include "SanKit/sandef.h"
#include "SanKit/sanvar.h"
#include "SanKit/sancmd.h"
#include "SanKit/sanepd.h"
#include "SanKit/sanhsh.h"
#include "SanKit/sanhst.h"
#include "SanKit/sanpos.h"
#include "SanKit/sansss.h"
#include "SanKit/santag.h"
#include "SanKit/santrm.h"
#include "SanKit/sanutl.h"
#endif


/*--> SANTerm: one time call termination */
nonstatic
void
SANTerm(void)
  {
/* terminate the positional evaluation subsystem */

  SANPosTerm();

/* terminate the search strategy subsystem */

  SANSSSTerm();

/* terminate the history subsystem */

  SANHistTerm();

/* terminate the hash code subsystem */

  SANHashTerm();

/* terminate the command processing subsystem */

  SANCMDTerm();

/* terminate the EPD subsystem */

  SANEPDTerm();

/* terminate the tag environment subsystem */

  SANTagTerm();

/* release the tree leg storage */

  SANMemFree(Tree);

/* close the dribble output file if needed */

  if (do_fptr != NULL)
    {
    SANTextFileClose(do_fptr);
    do_fptr = NULL;
    }
  ;

  return;
  }

/*<<< santrm.c: EOF */
