/*>>> stdtype.h: portable types for Jester */

/* Revised: 02-20-2001 17:00:17 */

/* true NULL */

#ifdef NULL
#undef NULL
#endif
#define NULL ((void *) 0)

/* subprogram nonstatic storage class indication */

#define nonstatic

/* a bit */

#define bit 0x01

/* 16 bit short integer and 32 bit long integer types */

typedef short int siT, boolT, *siptrT;
typedef long int liT, *liptrT;

/* 16 bit short integer and 32 bit long integer types (unsigned) */

typedef unsigned short int usiT, *usiptrT;
typedef unsigned long int uliT, *uliptrT;

/* some handy types */

typedef void *voidptrT;
typedef char *charptrT;
typedef unsigned char byteT, *byteptrT;
typedef FILE *FILEptrT;
typedef unsigned long int allocT;

/* bit widths */

#define nybbW 4
#define byteW (2 * nybbW)
#define wordW (2 * byteW)
#define dwrdW (2 * wordW)
#define qwrdW (2 * dwrdW)

/* byte legnths */

#define byteL 1
#define wordL (2 * byteL)
#define dwrdL (2 * wordL)
#define qwrdL (2 * dwrdL)

/* masks */

#define nybbM (0x0f)
#define byteM (0x00ff)
#define wordM (0x0000ffffL)

/* some handy macros */

#define map_lower(ch) (isupper((ch)) ? tolower((ch)) : (ch))
#define map_upper(ch) (islower((ch)) ? toupper((ch)) : (ch))

#ifdef max
#undef max
#endif
#define max(x, y) (((x) > (y)) ? (x) : (y))

#ifdef min
#undef min
#endif
#define min(x, y) (((x) < (y)) ? (x) : (y))
